Imports System.IO
Imports DatasetViewerTester.PersonProfessionDts

Public Class frmPersonProfession

   Private _DataFile As New FileInfo("..\..\PersonProfessionDts.Xml")

   Public Sub New()
      InitializeComponent()
      PersonProfessionDts.ReadXml(_DataFile.FullName)
   End Sub

   Private Sub Form1_FormClosed(sender As Object, e As FormClosedEventArgs) Handles MyBase.FormClosed
      While Controls.Count > 0
         'there is a winforms-bug, that components get disposed first. This leads to exceptions, when ComboboxDatagridViewColumns Datasources become invalid. Workaround: Dispose controls first
         Controls(0).Dispose()
      End While
      PersonProfessionDts.WriteXml(_DataFile.FullName)
   End Sub

   Private Sub btPersonsOfProfession_Click(sender As Object, e As EventArgs) Handles btPersonsOfProfession.Click
      Dim OutputLines As New List(Of String)()
      For Each rwProfession As ProfessionRow In PersonProfessionDts.Profession
         OutputLines.Add(rwProfession.Name & ": ")
         For Each rwPersonProfession As PersonProfessionRow In rwProfession.GetPersonProfessionRows()
            'indent Person-Names
            OutputLines.Add("     " & rwPersonProfession.PersonRow.Name)
         Next
      Next
      MessageBox.Show(String.Join(Environment.NewLine, OutputLines), "Persons of Professions")
   End Sub

   Private Sub btProfessionsOfPerson_Click(sender As Object, e As EventArgs) Handles btProfessionsOfPerson.Click
      Dim OutputLines As New List(Of String)()
      For Each rwPerson As PersonRow In PersonProfessionDts.Person
         OutputLines.Add(rwPerson.Name & ": ")
         For Each rwPersonProfession As PersonProfessionRow In rwPerson.GetPersonProfessionRows()
            'indent Professions-Namees
            OutputLines.Add("     " & rwPersonProfession.ProfessionRow.Name)
         Next
      Next
      MessageBox.Show(String.Join(Environment.NewLine, OutputLines), "Professions of Persons")
   End Sub

   Private Sub TestToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles TestToolStripMenuItem.Click

   End Sub

   Private Sub btShowDatasetViewer_Click(sender As Object, e As EventArgs) Handles btShowDatasetViewer.Click
      DatasetViewer.ShowDialog(Me.PersonProfessionDts)
   End Sub
End Class